/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the WhatsAppTemplateMessageCard type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WhatsAppTemplateMessageCard{}

// WhatsAppTemplateMessageCard struct for WhatsAppTemplateMessageCard
type WhatsAppTemplateMessageCard struct {
	CardIndex int64 `json:"card_index"`
	Components []WhatsAppTemplateMessageComponent `json:"components"`
}

// NewWhatsAppTemplateMessageCard instantiates a new WhatsAppTemplateMessageCard object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWhatsAppTemplateMessageCard(cardIndex int64, components []WhatsAppTemplateMessageComponent) *WhatsAppTemplateMessageCard {
	this := WhatsAppTemplateMessageCard{}
	this.CardIndex = cardIndex
	this.Components = components
	return &this
}

// NewWhatsAppTemplateMessageCardWithDefaults instantiates a new WhatsAppTemplateMessageCard object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWhatsAppTemplateMessageCardWithDefaults() *WhatsAppTemplateMessageCard {
	this := WhatsAppTemplateMessageCard{}
	return &this
}

// GetCardIndex returns the CardIndex field value
func (o *WhatsAppTemplateMessageCard) GetCardIndex() int64 {
	if o == nil {
		var ret int64
		return ret
	}

	return o.CardIndex
}

// GetCardIndexOk returns a tuple with the CardIndex field value
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateMessageCard) GetCardIndexOk() (*int64, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CardIndex, true
}

// SetCardIndex sets field value
func (o *WhatsAppTemplateMessageCard) SetCardIndex(v int64) {
	o.CardIndex = v
}

// GetComponents returns the Components field value
func (o *WhatsAppTemplateMessageCard) GetComponents() []WhatsAppTemplateMessageComponent {
	if o == nil {
		var ret []WhatsAppTemplateMessageComponent
		return ret
	}

	return o.Components
}

// GetComponentsOk returns a tuple with the Components field value
// and a boolean to check if the value has been set.
func (o *WhatsAppTemplateMessageCard) GetComponentsOk() ([]WhatsAppTemplateMessageComponent, bool) {
	if o == nil {
		return nil, false
	}
	return o.Components, true
}

// SetComponents sets field value
func (o *WhatsAppTemplateMessageCard) SetComponents(v []WhatsAppTemplateMessageComponent) {
	o.Components = v
}

func (o WhatsAppTemplateMessageCard) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WhatsAppTemplateMessageCard) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["card_index"] = o.CardIndex
	toSerialize["components"] = o.Components
	return toSerialize, nil
}

type NullableWhatsAppTemplateMessageCard struct {
	value *WhatsAppTemplateMessageCard
	isSet bool
}

func (v NullableWhatsAppTemplateMessageCard) Get() *WhatsAppTemplateMessageCard {
	return v.value
}

func (v *NullableWhatsAppTemplateMessageCard) Set(val *WhatsAppTemplateMessageCard) {
	v.value = val
	v.isSet = true
}

func (v NullableWhatsAppTemplateMessageCard) IsSet() bool {
	return v.isSet
}

func (v *NullableWhatsAppTemplateMessageCard) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWhatsAppTemplateMessageCard(val *WhatsAppTemplateMessageCard) *NullableWhatsAppTemplateMessageCard {
	return &NullableWhatsAppTemplateMessageCard{value: val, isSet: true}
}

func (v NullableWhatsAppTemplateMessageCard) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWhatsAppTemplateMessageCard) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


